#! /usr/bin/python

# Authentication
ldap_dn = "cn=root"
ldap_pwd = "object00"
ldap_server = "localhost"
sameb_uid = "sec_master"
sameb_pwd = "object00"

# The part of the LDAP tree where you expect users
ldap_base = "o=xyz"

# The part of the LDAP tree where the SAMeb 
# configuration is located
ldap_sameb_base = "secAuthority=Default"

# Internal configuration
ldap_user_file = "ldap_users"
uid_file = "uid_file"

from subprocess import call

call("ldapsearch -LLL -D " + ldap_dn + " -w " + ldap_pwd 
	+ " -b " + ldap_base + " -h " + ldap_server
	" objectclass=inetOrgPerson dn >" + ldap_user_file,
		shell=True)

ldap_users = open(ldap_user_file, "r")

for line in ldap_users:
	if len(line) > 1:
		dn = line[4:-1]
		ret_val = call("ldapsearch -D " + ldap_dn +
			" -w " + ldap_pwd + " -h " + ldap_server +
			" -b " + ldap_sameb_base + " secDN=" + dn + 
			" | grep numEntries > /dev/null",
			shell=True)
		if (ret_val == 1):
			print "Need to import " + dn
			call("ldapsearch -D " + ldap_dn +
				" -w " + ldap_pwd + 
				" -h " + ldap_server + " -b " + dn +
				" objectClass=inetOrgPerson uid " + 
				"| grep uid: >" + uid_file, 
				shell=True)
			uid_f = open(uid_file, "r")
			uid = uid_f.read()
			uid_f.close()
			uid = uid[5:-1]
			call("pdadmin -a " + sameb_uid + " -p " +
				sameb_pwd + " user import " + uid + 
				" " + dn,
				shell=True);
			call("pdadmin -a " + sameb_uid + " -p " +
				sameb_pwd + " user modify " + uid + 
				"account-valid yes ",
				shell=True);